local name = 'kEnergy'

function kEnergy:CreateFrame()
    self.frame = CreateFrame('Frame', name..'Frame', UIParent)
    self.frame:EnableMouse(true)
    self.frame:SetMovable(true)
    self.frame:SetWidth(self.db.profile.width)
    self.frame:SetHeight(self.db.profile.height)

    self.frame:SetScript('OnMouseDown', function(this, button)
        if (button == 'LeftButton') and not self.locked then
            this:StartMoving()
        end
    end)

    self.frame:SetScript('OnMouseUp', function(this, button)
        if (button == 'LeftButton') and not self.locked then
            this:StopMovingOrSizing()
            self:SavePosition()
        end
    end)

    self:SetCandyBarPoint(name, 'TOP', self.frame, 'TOP', 0, 0)
    self:SetCandyBarPoint(name, 'BOTTOM', self.frame, 'BOTTOM', 0, 0)
    self:SetCandyBarPoint(name, 'LEFT', self.frame, 'LEFT', 0, 0)
    self:SetCandyBarPoint(name, 'RIGHT', self.frame, 'RIGHT', 0, 0)
end

function kEnergy:RestorePosition()
    if(self.db.profile.pos) then
        local x, y = string.split(' ', self.db.profile.pos)
        local s = self.frame:GetEffectiveScale()

        self.frame:ClearAllPoints()
        self.frame:SetPoint('TOPLEFT', UIParent, 'BOTTOMLEFT', x/s, y/s)
    else
        self.frame:ClearAllPoints()
        self.frame:SetPoint('CENTER', UIParent, 'CENTER', 0, 0)
    end
end

function kEnergy:SavePosition()
    local f = self.frame
    local x,y = f:GetLeft(), f:GetTop()
    local s = f:GetEffectiveScale()

    x, y = x*s, y*s

    self.db.profile.pos = string.format('%s %s', x, y)
end
